Index: orxonox/trunk/src/p_node.cc
===================================================================
--- orxonox/trunk/src/p_node.cc	(revision 3364)
+++ orxonox/trunk/src/p_node.cc	(revision 3365)
@@ -14,4 +14,8 @@
    main-programmer: Patrick Boenzli
    co-programmer: ...
+
+   \todo Null-Parent => center of the coord system - singleton
+   \todo Smooth-Parent: delay, speed
+   \todo destroy the stuff again, delete...
 */
 
@@ -28,5 +32,32 @@
    \todo this constructor is not jet implemented - do it
 */
-PNode::PNode () {}
+PNode::PNode () 
+{
+  this->children = new tList<PNode>();
+  this->bRelCoorChanged = true;
+  this->bAbsCoorChanged = false;
+  this->bRelDirChanged = true;
+  this->bAbsDirChanged = false;
+  this->parent = NULL;
+}
+
+
+/**
+   \brief constructor with coodinates
+*/
+PNode::PNode (Vector* absCoordinate, PNode* parent )
+{
+  this->absCoordinate = *absCoordinate;
+  this->relCoordinate = this->absCoordinate - parent->getAbsCoor ();
+  
+  this->children = new tList<PNode>();
+  this->bRelCoorChanged = true;
+  this->bAbsCoorChanged = false;
+  this->bRelDirChanged = true;
+  this->bAbsDirChanged = false;
+  this->parent = parent;
+
+  parent->addChild (this);
+}
 
 
@@ -36,4 +67,376 @@
    \todo this deconstructor is not jet implemented - do it
 */
-PNode::~PNode () {}
-
+PNode::~PNode () 
+{
+  /*
+  delete &this->children;
+  delete &this->relCoordinate;
+  delete &this->absCoordinate;
+  delete &this->relDirection;
+  delete &this->absDirection;
+  */
+  this->parent = NULL;
+  /* there is currently a problem with cleaning up - fix*/
+}
+
+
+/**
+   \brief deletes the hole pnode tree
+
+   cleans up all pnodes
+*/
+void PNode::destroy ()
+{
+  PNode* pn = this->children->enumerate();
+  while( pn != NULL) 
+    { 
+      pn->destroy ();
+      pn = this->children->nextElement();
+    } 
+  this->children->destroy ();
+}
+
+
+/**
+   \brief get relative coordinates
+   \returns relative coordinates to its parent
+*/
+Vector PNode::getRelCoor ()
+{
+  Vector r = this->relCoordinate; /* return a copy, so it can't be modified */
+  return r;
+}
+
+
+/**
+   \brief set relative coordinates
+   \param relative coordinates to its parent
+
+   it is very importand, that you use this function, if you want to update the
+   relCoordinates. If you don't use this, the PNode won't recognize, that something
+   has changed and won't update the children Nodes.
+*/
+void PNode::setRelCoor (Vector* relCoord)
+{
+  this->bRelCoorChanged = true;
+  this->relCoordinate = *relCoord;
+}
+
+
+/**
+   \brief get absolute coordinates
+   \returns absolute coordinates from (0,0,0)
+*/
+Vector PNode::getAbsCoor ()
+{
+  return this->absCoordinate;
+}
+
+
+/**
+   \brief get relative coordinates
+   \returns relative coordinates to its parent
+
+   it is very importand, that you use this function, if you want to update the
+   absCoordinates. If you don't use this, the PNode won't recognize, that something
+   has changed and won't update the children Nodes.
+*/
+void PNode::setAbsCoor (Vector* absCoord)
+{
+  this->bAbsCoorChanged = true;
+  this->absCoordinate = *absCoord;
+}
+
+
+/**
+   \brief shift coordinate (abs and rel)
+   \param shift vector
+
+   this function shifts the current coordinates about the vector shift. this is
+   usefull because from some place else you can:
+   PNode* someNode = ...;
+   Vector objectMovement = calculateShift();
+   someNode->shiftCoor(objectMovement);
+
+   elsewhere you would have to:
+   PNode* someNode = ...;
+   Vector objectMovement = calculateShift();
+   Vector currentCoor = someNode->getRelCoor();
+   Vector newCoor = currentCoor + objectMovement;
+   someNode->setRelCoor(newCoor);
+   
+   yea right... shorter...
+
+*/
+void PNode::shiftCoor (Vector* shift)
+{
+  if( this->bAbsCoorChanged)
+    {
+      this->absCoordinate = this->absCoordinate + *shift;
+    }
+  else 
+    {
+      this->relCoordinate = this->relCoordinate + *shift;
+      this->bRelCoorChanged = true;
+    }
+}
+
+
+
+/**
+   \brief get relative direction
+   \returns relative direction to its parent
+*/
+Quaternion PNode::getRelDir ()
+{
+  return this->relDirection;
+}
+
+
+/**
+   \brief set relative direction
+   \param relative direction to its parent
+
+   it is very importand, that you use this function, if you want to update the
+   relDirection. If you don't use this, the PNode won't recognize, that something
+   has changed and won't update the children Nodes.
+*/
+void PNode::setRelDir (Quaternion* relDir)
+{
+  this->bRelCoorChanged = true;
+  this->relDirection = *relDir;
+}
+
+
+/**
+   \brief gets the absolute direction (0,0,1)
+   \returns absolute coordinates
+*/
+Quaternion PNode::getAbsDir ()
+{}
+
+
+/**
+   \brief sets the absolute direction (0,0,1)
+   \param absolute coordinates
+
+   it is very importand, that you use this function, if you want to update the
+   absDirection. If you don't use this, the PNode won't recognize, that something
+   has changed and won't update the children Nodes.
+*/
+void PNode::setAbsDir (Quaternion* absDir)
+{}
+
+
+/**
+   \brief shift coordinate (abs and rel)
+   \param shift vector
+
+   this function shifts the current coordinates about the vector shift. this is
+   usefull because from some place else you can:
+   PNode* someNode = ...;
+   Quaternion objectMovement = calculateShift();
+   someNode->shiftCoor(objectMovement);
+
+   elsewhere you would have to:
+   PNode* someNode = ...;
+   Quaternion objectMovement = calculateShift();
+   Quaternion currentCoor = someNode->getRelCoor();
+   Quaternion newCoor = currentCoor + objectMovement;
+   someNode->setRelCoor(newCoor);
+   
+   yea right... shorter...
+
+*/
+void PNode::shiftDir (Quaternion* shift)
+{}
+
+
+
+/**
+   \brief adds a child and makes this node to a parent
+   \param child reference
+
+   use this to add a child to this node.
+*/
+void PNode::addChild (PNode* pNode)
+{
+  this->addChild(pNode, DEFAULT_MODE);
+}
+
+
+/**
+   \brief adds a child and makes this node to a parent
+   \param child reference
+   \param on which changes the child should also change ist state
+
+   use this to add a child to this node.
+*/
+void PNode::addChild (PNode* pNode, parentingMode mode)
+{
+  pNode->mode = mode;
+  pNode->parent = this;
+  this->children->add (pNode);
+}
+
+
+/**
+   /brief removes a child from the node
+*/
+void PNode::removeChild (PNode* pNode)
+{
+  this->children->remove (pNode);
+}
+
+
+/**
+   \brief sets the parent of this PNode
+*/
+void PNode::setParent (PNode* parent)
+{
+  this->parent = parent;
+}
+
+/**
+   \brief set the mode of this parent manualy
+*/
+void PNode::setMode (parentingMode mode)
+{
+  this->mode = mode;
+}
+
+/**
+   \brief has to be called, if the parent coordinate has changed
+   
+   normaly this will be done by the parent itself automaticaly. If you call this, you
+   will force an update of the coordinated of the node.
+*/
+void PNode::parentCoorChanged ()
+{
+  this->bRelCoorChanged = true;
+}
+
+
+/**
+   \brief has to be called, if the parent direction has changed
+   
+   normaly this will be done by the parent itself automaticaly. If you call this, you
+   will force an update of the direction of the node.
+*/
+void PNode::parentDirChanged ()
+{
+  this->bRelDirChanged = true;
+}
+
+
+/**
+   \brief updates the absCoordinate/absDirection
+
+   this is used to go through the parent-tree to update all the absolute coordinates
+   and directions. this update should be done by the engine, so you don't have to 
+   worry, normaly...
+*/
+void PNode::update (float timeStamp)
+{
+  printf ("PNode::update - %s - (%f, %f, %f)\n", this->objectName, this->absCoordinate.x, this->absCoordinate.y, this->absCoordinate.z);
+
+      if( this->mode == MOVEMENT || this->mode == ALL)
+	{
+	  if( this->bAbsCoorChanged /*&& this->timeStamp != DataTank::timeStamp*/)
+	    {
+	      printf("PNode::update () - this->bAbsCoorChanged = true\n");
+	      /* if you have set the absolute coordinates this overrides all other changes */
+	      this->relCoordinate = this->absCoordinate - parent->getAbsCoor ();
+	    }
+	  else if( this->bRelCoorChanged /*&& this->timeStamp != DataTank::timeStamp*/)
+	    {
+	      /*this is bad style... must be deleted later - just for testing*/
+	      if( this->parent == NULL)
+		{
+		this->absCoordinate = this->relCoordinate;
+		}
+	      else
+		this->absCoordinate = parent->getAbsCoor () + this->relCoordinate;	      /* update the current absCoordinate */
+	    }
+	}
+      
+      if( this->mode == ROTATION && this->mode == ALL)
+	{
+	  if( this->bAbsDirChanged /*&& this->timeStamp != DataTank::timeStamp*/)
+	    {
+	      /* if you have set the absolute coordinates this overrides all other changes */
+	      this->relDirection = this->absDirection - parent->getAbsDir ();
+	    }
+	  else if( this->bRelDirChanged /*&& this->timeStamp != DataTank::timeStamp*/)
+	    {
+	      /* update the current absDirection - remember * means rotation around sth.*/
+	      this->absDirection = parent->getAbsDir () * this->relDirection;
+	    }
+	}    
+      // }
+  PNode* pn = this->children->enumerate();
+  while( pn != NULL) 
+    { 
+      /* if this node has changed, make sure, that all children are updated also */
+      if( this->bRelCoorChanged || this->bAbsCoorChanged)
+	pn->parentCoorChanged ();
+      if( this->bRelDirChanged || this->bAbsDirChanged)
+	pn->parentDirChanged ();
+      pn->update(timeStamp);
+      pn = this->children->nextElement();
+    }
+
+  this->timeStamp = timeStamp;
+  this->bRelCoorChanged = false;
+  this->bAbsCoorChanged = false;
+  this->bRelDirChanged = false;
+  this->bAbsDirChanged = false;
+}
+
+
+/*
+  \brief tick
+*/
+void PNode::processTick (float dt)
+{
+  this->tick (dt);
+  PNode* pn = this->children->enumerate();
+  while( pn != NULL) 
+    { 
+      pn->processTick (dt);
+      pn = this->children->nextElement();
+    } 
+}
+
+
+void PNode::tick (float dt)
+{}
+
+
+void PNode::debug()
+{
+  printf("PNode::debug() - absCoord: (%f, %f, %f)\n", 
+	 this->absCoordinate.x, 
+	 this->absCoordinate.y,
+	 this->absCoordinate.z);
+}
+
+
+/*
+  \brief set the name of the node
+
+  for debug purposes realy usefull, not used to work properly
+*/
+void PNode::setName (char* newName)
+{
+  this->objectName = newName;
+}
+
+
+/*
+  \brief gets the name of the node
+*/
+char* PNode::getName ()
+{
+  return this->objectName;
+}
Index: orxonox/trunk/src/p_node.h
===================================================================
--- orxonox/trunk/src/p_node.h	(revision 3364)
+++ orxonox/trunk/src/p_node.h	(revision 3365)
@@ -14,6 +14,6 @@
     this conditions make it cheaper to recalculate the tree (reduces redundant work).
 
-    remember: if you have to change the coordinates, because the object (point) did move,
-    don't forget to reset both relCoor and absCoor (offset is the same)
+    remember: if you have to change the coordinates or the directions, use the functions
+    that are defined to execute this operation - otherwhise there will be big problems...
 */
 
@@ -24,28 +24,62 @@
 #include "stdincl.h"
 
+class PNode; /* forward decleration, so that parentEntry has access to PNode */
 
-class PNode {
+typedef enum parentingMode {MOVEMENT = 0, ROTATION, ALL};
+#define DEFAULT_MODE ALL
+
+class PNode : public BaseObject {
 
  public:
   PNode ();
-  ~PNode ();
+  PNode (Vector* absCoordinate, PNode* pNode);
+  virtual ~PNode ();
+
+  void destroy ();
+
+  PNode* parent; //! a pointer to the parent node
+  tList<PNode>* children; //! list of the children
+
+  parentingMode mode;
 
   Vector getRelCoor ();
-  void setRelCoor (Vector relCoord);
+  void setRelCoor (Vector* relCoord);
+  //void setRelCoor (Vector relCoord);
   Vector getAbsCoor ();
-  void setAbsCoor (Vector absCoord);
+  void setAbsCoor (Vector* absCoord);
+  //void setAbsCoor (Vector absCoord);
+  void shiftCoor (Vector* shift);
+  //void shiftCoor (Vector shift);
 
   Quaternion getRelDir ();
-  void setRelDir (Quaternion relDir);
+  void setRelDir (Quaternion* relDir);
   Quaternion getAbsDir ();
-  void setAbsCoor (Quaternion absDir);
+  void setAbsDir (Quaternion* absDir);
+  void shiftDir (Quaternion* shift);
 
   void addChild (PNode* pNode);
+  void addChild (PNode* pNode, parentingMode mode);
   void removeChild (PNode* pNode);
+  void setParent (PNode* parent);
+  void parentCoorChanged ();
+  void parentDirChanged ();
+  void setMode (parentingMode mode);
 
- private:
-  long timeStamp; //! this the timeStamp of when the abs{Coordinat, Direction} has been calculated
-  bool bCoorChanged;
-  bool bDirChanged;
+  virtual void update (float timeStamp);
+  void processTick (float dt);
+  virtual void tick (float dt);
+
+  void setName (char* newName);
+  char* getName ();
+
+
+  void debug ();
+
+  float timeStamp;   //! this the timeStamp of when the abs{Coordinat, Direction} has been calculated
+  char* objectName;
+  bool bAbsCoorChanged;
+  bool bRelCoorChanged;
+  bool bRelDirChanged;
+  bool bAbsDirChanged;
 
   Vector relCoordinate;  //! coordinates relative to the parent
@@ -54,6 +88,4 @@
   Quaternion absDirection; //! absolute direvtion in the world ( from (0,0,1) )
 
-  tList<PNode>* children; //! list of the children
-
 };
 
Index: orxonox/trunk/src/player.cc
===================================================================
--- orxonox/trunk/src/player.cc	(revision 3364)
+++ orxonox/trunk/src/player.cc	(revision 3365)
@@ -19,4 +19,5 @@
 #include "stdincl.h"
 #include "collision.h"
+#include "importer/model.h"
 
 using namespace std;
@@ -26,5 +27,5 @@
 {
 
-  this->obj = new Object("reaplow.obj");
+  this->model = new Model("reaplow.obj");
   /*
   objectList = glGenLists(1);
@@ -54,10 +55,10 @@
 }
 
-Player::~Player()
+Player::~Player ()
 {
-  delete this->obj;
+  delete this->model;
 }
 
-void Player::postSpawn()
+void Player::postSpawn ()
 {
   travelSpeed = 15.0;
@@ -69,23 +70,23 @@
 }
 
-void Player::tick(float time)
+void Player::tick (float time)
 {
   // movement
-  move (time);
+  this->move (time);
 }
 
-void Player::hit(WorldEntity* weapon, Vector loc)
+void Player::hit (WorldEntity* weapon, Vector loc)
 {
 }
 
-void Player::destroy()
+void Player::destroy ()
 {
 }
 
-void Player::collide(WorldEntity* other, Uint32 ownhitflags, Uint32 otherhitflags)
+void Player::collide (WorldEntity* other, Uint32 ownhitflags, Uint32 otherhitflags)
 {
 }
 
-void Player::command(Command* cmd)
+void Player::command (Command* cmd)
 {
   //printf("Player|recieved command [%s]\n", cmd->cmd);
@@ -97,5 +98,5 @@
 }
 
-void Player::draw()
+void Player::draw ()
 { 
   glMatrixMode(GL_MODELVIEW);
@@ -103,17 +104,16 @@
   float matrix[4][4];
   
-  glTranslatef(getPlacement()->r.x, getPlacement()->r.y, getPlacement()->r.z);
-  getPlacement()->w.matrix (matrix);
+  glTranslatef (this->getAbsCoor ().x, this->getAbsCoor ().y, this->getAbsCoor ().z);
+  //rotate
+  this->getAbsDir ().matrix (matrix);
   glMultMatrixf((float*)matrix);
   
   glMatrixMode(GL_MODELVIEW);
-  glRotatef(-90, 0,1,0);
-  obj->draw();
+  this->model->draw();
   // glCallList(objectList);
-
-  
-  
 }
 
+
+/*PN
 void Player::getLookat(Location* locbuf)
 {
@@ -121,28 +121,30 @@
   //locbuf->dist += 5.0;
 }
+*/
 
-void Player::leftWorld()
+void Player::leftWorld ()
 {
 }
 
-void Player::move(float time)
+void Player::move (float time)
 {
   Vector accel(0.0, 0.0, 0.0);
   /* FIXME: calculating the direction and orthDirection every timeSlice is redundant! save it somewhere */
-  Placement *pos = getPlacement();
+  //Placement *pos = getPlacement();
+  
   /* calculate the direction in which the craft is heading  */
-  Vector direction(0.0, 0.0, 1.0);
-  direction = pos->w.apply(direction);
-  Vector orthDirection(0.0, 0.0, 1.0);
-  orthDirection = orthDirection.cross(direction);
+  Vector direction (1.0, 0.0, 0.0);
+  //direction = this->absDirection.apply (direction);
+  Vector orthDirection (0.0, 0.0, 1.0);
+  //orthDirection = orthDirection.cross (direction);
 
   if( bUp) { accel = accel+(direction*acceleration); }
   if( bDown) { accel = accel-(direction*acceleration); }
-  if( bLeft ) { accel = accel + (orthDirection*acceleration); }
-  if( bRight ) { accel = accel - (orthDirection*acceleration); }
+  if( bLeft ) { accel = accel - (orthDirection*acceleration); }
+  if( bRight ) { accel = accel + (orthDirection*acceleration); }
   if( bAscend ) { /* not yet implemented but just: (0,0,1)*acceleration */}
   if( bDescend) {/* FIXME */} /* \todo up and down player movement */
 
-  Location* l = getLocation();
+  //Location* l = getLocation();
   
   // r(t) = r(0) + v(0)*t + 1/2*a*t^2
@@ -152,7 +154,12 @@
 
   /* this the base-speed of the player: determines how fast and how the player follows the track*/
-  l->dist = l->dist + travelSpeed * time;
-
+  //l->dist = l->dist + travelSpeed * time;
+  
+  Vector* shift = new Vector (this->travelSpeed * time, 0, 0);
+  this->shiftCoor (shift);
+  
   /* this updates the player position on the track - user interaction */
-  l->pos = l->pos + accel*time;
+  //l->pos = l->pos + accel*time;
+  Vector move = accel * time;
+  this->shiftCoor (&move);
 }
Index: orxonox/trunk/src/player.h
===================================================================
--- orxonox/trunk/src/player.h	(revision 3364)
+++ orxonox/trunk/src/player.h	(revision 3365)
@@ -8,5 +8,6 @@
 
 #include "world_entity.h"
-#include "importer/object.h"
+
+class Model;
 
 //! Basic controllable WorldEntity
@@ -27,5 +28,5 @@
   
   virtual void draw();
-  virtual void getLookat(Location* locbuf);
+  // virtual void getLookat(Location* locbuf);
   
   virtual void leftWorld();
@@ -38,5 +39,4 @@
   float acceleration;
   GLuint objectList;
-  Object* obj;
   
   void move(float time);
Index: orxonox/trunk/src/proto_class.cc
===================================================================
--- orxonox/trunk/src/proto_class.cc	(revision 3364)
+++ orxonox/trunk/src/proto_class.cc	(revision 3365)
@@ -27,5 +27,8 @@
    \todo this constructor is not jet implemented - do it
 */
-ProtoClass::ProtoClass () {}
+ProtoClass::ProtoClass () 
+{
+   this->setClassName ("ProtoClass");
+}
 
 
Index: orxonox/trunk/src/proto_class.h
===================================================================
--- orxonox/trunk/src/proto_class.h	(revision 3364)
+++ orxonox/trunk/src/proto_class.h	(revision 3365)
@@ -19,5 +19,5 @@
    here can be some longer description of this class
 */
-class ProtoClass {
+class ProtoClass : public BaseObject {
 
  public:
Index: orxonox/trunk/src/stdincl.h
===================================================================
--- orxonox/trunk/src/stdincl.h	(revision 3364)
+++ orxonox/trunk/src/stdincl.h	(revision 3365)
@@ -10,4 +10,6 @@
 
 #define null 0   //!< null
+
+typedef unsigned char byte;
 
 // this includes the information from configure/makefiles
@@ -31,5 +33,7 @@
 
 #include "vector.h"
-#include "coordinates.h"
+#include "matrix.h"
+#include "curve.h"
+//#include "coordinates.h"
 #include "list.h"
 #include "list_template.h"
@@ -38,4 +42,6 @@
 #include "message_structures.h"
 #include "orxonox.h"
+#include "data_tank.h"
+#include "base_object.h"
 
 #endif /* _STDINCL_H */
Index: orxonox/trunk/src/story_entity.h
===================================================================
--- orxonox/trunk/src/story_entity.h	(revision 3364)
+++ orxonox/trunk/src/story_entity.h	(revision 3365)
@@ -12,5 +12,5 @@
 
 //! A class that represents something to play in orxonox. it is a container for worlds, movies, mission briefings, etc...
-class StoryEntity {
+class StoryEntity : public BaseObject {
 
  public:
Index: orxonox/trunk/src/track.cc
===================================================================
--- orxonox/trunk/src/track.cc	(revision 3364)
+++ orxonox/trunk/src/track.cc	(revision 3365)
@@ -29,4 +29,5 @@
   this->end = NULL;
   this->nextID = 0;
+  this->setClassName ("Track");
 }
 
@@ -44,4 +45,5 @@
   this->end = finish;
   this->nextID = next;
+  this->setClassName ("Track");
 }
 
@@ -59,71 +61,5 @@
 
 
-/**
-   \brief calculate a camera Placement from a "look at"-Location
-   \param lookat: the Location the camera should be centered on
-   \param camplc: pointer to a buffer where the new camera Placement should be put into
-   
-   Theoretically you can place the camera wherever you want, but for the sake of 
-   common sense I suggest that you at least try to keep the thing that should be looked
-   at inside camera boundaries.
-*/
-void Track::mapCamera (Location* lookat, Placement* camplc)
-{
-  Line trace(*offset, *end - *offset);
-  float l = trace.len ();
-  
-  //	camplc->r = *offset + Vector(0,0,0.5);
-  //	camplc->w = Quaternion (trace.a, Vector(0,0,1));
-  float r = (lookat->dist)*PI / l;
-  camplc->r = trace.r + (trace.a * ((lookat->dist-10.0) / l)) + Vector(0,0,5.0);
-  
-  Vector w(0.0,0.0,0.0);
-  w=Vector(0,0,0) - ((trace.r + (trace.a * ((lookat->dist) / l)) - camplc->r));
-  //Vector up(0.0,sin(r),cos(r)); // corrupt...
-  Vector up(0.0, 0.0, 1.0);
 
-  camplc->w = Quaternion(w, up);
-
-  //printf("\n------\nup vector: [%f, %f, %f]\n", up.x, up.y, up.z);
-  //printf("direction: [%f, %f, %f]\n", w.x, w.y, w.z);
-  //printf("quaternion: w[ %f ], v[ %f, %f, %f ]\n", camplc->w.w, camplc->w.v.x, camplc->w.v.y, camplc->w.v.z);
-}
-
-/**
-   \brief calculate a Placement from a given Location
-   \param loc: the Location the entity is in
-   \param plc: a pointer to a buffer where the corresponding Placement should be put
-   into
-   \return: true if track changes - false if track stays
-   
-   There are no limitations to how you transform a Location into a Placement, but for 
-   the sake of placement compatibility between track parts you should make sure that 
-   the resulting Placement at dist == 0 is equal to the offset Vector and the Placement
-   at dist == len() is equal to the end Vector. Elseway there will be ugly artifacts 
-   when transfering between track parts.
-*/
-bool Track::mapCoords (Location* loc, Placement* plc)
-{
-  Line trace(*offset, *end - *offset);
-  float l = trace.len ();
-  
-  /* change to the next track? */
-  if( loc->dist > l)
-    {
-      loc->dist -= l;
-      loc->part = nextID;
-      //FIXME: loc->track = this;
-      return true;
-    }
-  
-  /* this quaternion represents the rotation from start-vector (0,0,1) to the direction of
-   * the track */
-  Quaternion dir(trace.a, Vector(0,0,1)); 
-  
-  plc->r = trace.r + (trace.a * ((loc->dist) / l)) + /*dir.apply*/(loc->pos);
-  plc->w = dir * loc->rot;
-  
-  return false;
-}
 
 
Index: orxonox/trunk/src/track.h
===================================================================
--- orxonox/trunk/src/track.h	(revision 3364)
+++ orxonox/trunk/src/track.h	(revision 3365)
@@ -14,5 +14,5 @@
    To create special levels with special camera movement, rules or whatever, derive from this base class.
 */
-class Track 
+class Track : public BaseObject
 {
  private:
@@ -35,6 +35,4 @@
   virtual void postLeave (WorldEntity* entity);
   virtual void tick (float deltaT);
-  virtual void mapCamera (Location* lookat, Placement* camplc);
-  virtual bool mapCoords (Location* loc, Placement* plc);	// this should return true if the entity left track boundaries
 };
 
